/** @file Sequence.c
* Sequence : MSXE-302x : Sequence acquisition
* 
*
* @author C. Guinot
* @date 31.01.2007
* 
* @version  $LastChangedRevision$
* @version $LastChangedDate$
* 
* 
* @par LICENCE
* @verbatim
*  Copyright (C) 2004,2005  ADDI-DATA GmbH for the source code of this module.
*        
*        ADDI-DATA GmbH 
*        Airport Boulevard B210
*        D-77836 Rheinmnster Germany 
*        Tel: +49(0)7229/1847-0 
*        Fax: +49(0)7229/1847-200
*        http://www.addi-data-com 
*        info@addi-data.com 
*        
*
* @endverbatim   
*
* @par UPDATES                                                                                                          
* @verbatim                                                                                                             
*  Date      : 
*  Author        : 
*  Description   : 
*                                                                                                                       
* @endverbatim     
*
*
*/ 

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <io.h>
#include <math.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>


#include "..\..\..\..\Interface_Library\MSXE302x.nsmap"
#include "..\UTIL\utility.h"
#include "..\UTIL\socket.h"



void GetSequenceParameters(DWORD dw_NbrOfChannelsMax, 
						   DWORD *pdw_ChannelType,
						   DWORD *pdw_ChannelTypeMask,
                           DWORD *pdw_NbrOfChannels, 
                           struct MSXE302x__unsignedLong16FixedArrayParam *pdw_ChannelList, 
                           struct MSXE302x__unsignedLong16FixedArrayParam *pdw_Gain, 
                           struct MSXE302x__unsignedLong16FixedArrayParam *pdw_Polarity, 
                           DWORD *pdw_ConversionTime,
                           DWORD *pdw_ConversionTimeUnit,
                           DWORD *pdw_NbrOfSequence, 
                           DWORD *pdw_NbrMaxSequenceToTransfer, 
                           DWORD *pdw_DelayMode, 
                           DWORD *pdw_DelayTimeUnit, 
                           DWORD *pdw_DelayTime,
	                       DWORD *pdw_TriggerMask, 
			               DWORD *pdw_TriggerMode, 
			               DWORD *pdw_HardwareTriggerEdge, 
                           DWORD *pdw_HardwareTriggerCount, 
                           DWORD *pdw_ByTriggerNbrOfSeqToAcquire, 
                           DWORD *pdw_DataFormat)
{
	unsigned int i;
	DWORD dw_Choice = 0;

	do
	{
		printf("\nEnter the number of channels in sequence: ");
		scanf("%d", pdw_NbrOfChannels);
	}
	while ((*pdw_NbrOfChannels == 0) || (*pdw_NbrOfChannels > dw_NbrOfChannelsMax));

	for (i = 0; i < *pdw_NbrOfChannels; i++)
	{
		do
		{
			printf("\nEnter channel of sequence index %d: ", i);
			scanf("%lu", &pdw_ChannelList->ulValue[i]);
		}
		while (pdw_ChannelList->ulValue[i] > dw_NbrOfChannelsMax);
		do
		{
			printf("\nEnter the gain for the channel %d: (1 or 2)", pdw_ChannelList->ulValue[i]);
			scanf("%lu", &pdw_Gain->ulValue[pdw_ChannelList->ulValue[i]]);
		}
		while ((pdw_Gain->ulValue[pdw_ChannelList->ulValue[i]] > 2) ||(pdw_Gain->ulValue[pdw_ChannelList->ulValue[i]] ==0));

		do
		{
			printf("\nEnter the polarity for the channel %d: (0:Unipolar or 1:Bipolar)", pdw_ChannelList->ulValue[i]);
			scanf("%lu", &pdw_Polarity->ulValue[pdw_ChannelList->ulValue[i]]);
		}
		while (pdw_Polarity->ulValue[pdw_ChannelList->ulValue[i]] > 1);

		*pdw_ChannelTypeMask = *pdw_ChannelTypeMask | ((pdw_ChannelType[pdw_ChannelList->ulValue[i]]) << i); 


	}

	do
	{
		printf("\nEnter the conversion time unit (0: us, 1: ms, 2: s): ");
		scanf("%lu", pdw_ConversionTimeUnit);
	}
	while (*pdw_ConversionTimeUnit > 2);

	printf("\nEnter the conversion time value (min 10 us): ");
	scanf("%lu", pdw_ConversionTime);

	do
	{
		printf("\nEnter the number of sequences to acquire (0 = continuous): ");
		scanf("%d", pdw_NbrOfSequence);
	}
	while (*pdw_NbrOfSequence < 0);

	do
	{
		printf("\nEnter the number maximum of sequences to transfer: ");
		scanf("%d", pdw_NbrMaxSequenceToTransfer);
	}
	while ((*pdw_NbrMaxSequenceToTransfer < 1) || (*pdw_NbrMaxSequenceToTransfer > 65535));

//	Delay
	do
	{
		printf("0. Delay not used\n");
		printf("1. Delay mode 1 used\n");
		printf("2. Delay mode 2 used\n");
		printf("Select the delay mode You want to use: ");
		scanf("%d", pdw_DelayMode);
	}
	while ((*pdw_DelayMode != 0) && (*pdw_DelayMode != 1) && (*pdw_DelayMode != 2));

	if (*pdw_DelayMode != 0)
	{
		do
		{
			printf("Select the delay timebase You want to use (0, Microseconds, 1 = Miliseconds, 2 = Seconds): ");
			scanf("%d", pdw_DelayTimeUnit);
		}
		while (*pdw_DelayTimeUnit > 2);

		do
		{
			printf("\nEnter the delay value: ");
			scanf("%d", pdw_DelayTime );
		}
		while ((*pdw_DelayTime  < 0) || (*pdw_DelayTime  > 65535));
	}
	else
	{
		*pdw_DelayTimeUnit = 0;
		*pdw_DelayTime = 0;
	}
	/* TRIGGER SELECTION */
	*pdw_TriggerMask = 0;
	*pdw_TriggerMode = 0;
	*pdw_HardwareTriggerEdge = 0;
	*pdw_HardwareTriggerCount = 0;
	*pdw_ByTriggerNbrOfSeqToAcquire = 0;

    printf("\nDo You want to use the hardware trigger (0 or 1)? ");
	scanf("%d", &dw_Choice);

	if (dw_Choice == 1)
	{
        *pdw_TriggerMask = *pdw_TriggerMask | 1;

		do 
		{
			printf("\n1. rising edge\n");
			printf("2. falling edge\n");
			printf("3. both edges\n");
			printf("Select the active edge: ");
			scanf ("%d", &dw_Choice);
		}
		while ((dw_Choice < 1) || (dw_Choice > 3));

		*pdw_HardwareTriggerEdge = dw_Choice;

		do
		{
			printf("\nEnter the number of edges before the trigger action occure (1 to 65535): ");
			scanf("%d",pdw_HardwareTriggerCount);
		}
		while ((*pdw_HardwareTriggerCount == 0) || (*pdw_HardwareTriggerCount > 65535));


	}

	if (*pdw_TriggerMask == 0)
	{
	    printf("\nDo You want to use the Synchro trigger (0 or 1)? ");
		scanf("%d", &dw_Choice);

		if (dw_Choice == 1)
		{
			*pdw_TriggerMask = *pdw_TriggerMask | 2;

		}
	}


    if (*pdw_TriggerMask != 0)
    {
		do
		{
			printf("\n1. One shot trigger\n");
			printf("2. Sequence trigger\n");
			printf("Select the trigger mode do You want to use: ");
			scanf("%d", pdw_TriggerMode);
		}
		while ((*pdw_TriggerMode != 1) && (*pdw_TriggerMode != 2));


    	if (*pdw_TriggerMode == 2)
        {
            do
	    	{
		    	printf("\nEnter the number of sequence to acquire by each trigger: ");
			    scanf("%d", pdw_ByTriggerNbrOfSeqToAcquire);
		    }
		    while (*pdw_ByTriggerNbrOfSeqToAcquire == 0);
        }


    }


// Data format
	*pdw_DataFormat = 0;

	do 
	{
	    printf("\nDo You want to receive a time stamp (0: No, 1: Yes) ?");
	    scanf ("%d",&dw_Choice);
	}
	while (dw_Choice > 1);

	*pdw_DataFormat = dw_Choice;

	do 
	{
	    printf("\nDo You want to receive a Sequence counter (0: No, 1: Yes) ?");
	    scanf ("%d",&dw_Choice);
	}
	while (dw_Choice > 1);

	*pdw_DataFormat = *pdw_DataFormat | (dw_Choice << 1);

	do 
	{
	    printf("\nDo You want to receive the value in digital form (tape 0) or in analog form (type 1) ?");
	    scanf ("%d",&dw_Choice);
	}
	while (dw_Choice > 1);

	*pdw_DataFormat = *pdw_DataFormat | (dw_Choice << 2);

	

}


#define MAX_SOKET_DATA_FIFO 100

typedef struct
      {
      BYTE      b_Exit;
      INT       i_Handle;
      DWORD    dw_DataFormat;
      DWORD    dw_NumberOfChannelsToAcquire;
	  DWORD    dw_NbrMaxSequenceToTransfer;
	  DWORD    dw_ChannelTypeMask;
	  DWORD    dw_SingelSequenceSize;
	  DWORD    dw_SocketDataSize;
      SOCKET    s_ClientSocket;
	  HANDLE    h_EventHandle;
	  struct
	     {
	     BYTE  *  pb_SocketData [MAX_SOKET_DATA_FIFO];
		 DWORD    dw_ReadPointer;
		 DWORD    dw_WritePointer;
		 BYTE      b_Overflow;
		 }s_SocketDataFIFO;
      }str_ThreadInfo;

#pragma pack(1)
typedef union
      {
      struct
	    {
	    DWORD dw_TimeStamp[2];
	    DWORD dw_Counter;
	    DWORD dw_BinaryValue[16];
	    }s_WichtTimeStampAndCounterBinaryData;

	 struct
	    {
	    DWORD dw_TimeStamp[2];
	    DWORD dw_Counter;
	    FLOAT  f_RealValue[16];
	    }s_WichtTimeStampAndCounterRealData;

      struct
	    {
	    DWORD dw_TimeStamp[2];
	    DWORD dw_BinaryValue[16];
	    }s_WichtTimeStampBinaryData;

	 struct
	    {
	    DWORD dw_TimeStamp[2];
	    FLOAT  f_RealValue[16];
	    }s_WichtTimeStampRealData;

      struct
	    {
	    DWORD dw_Counter;
	    DWORD dw_BinaryValue[16];
	    }s_WichtCounterBinaryData;

	 struct
	    {
	    DWORD dw_Counter;
	    FLOAT  f_RealValue[16];
	    }s_WichtCounterRealData;

      struct
	    {
	    DWORD dw_BinaryValue[16];
	    }s_BinaryData;

	 struct
	    {
	    FLOAT  f_RealValue[16];
	    }s_RealData;
	 }str_SequenceData;
#pragma pack()


DWORD WINAPI dw_ReadSocketThreadProc (LPVOID lpParameter)
        {
        str_ThreadInfo *  ps_ThreadInfo;
		INT                i_ReturnValue        = 0;
    	DWORD             dw_RequestValue       = 0;
    	DWORD             dw_NbrOfReceiveValues = 0;
        
        /**************************
        * Variable initialisation 
        ***************************/
        ps_ThreadInfo = (str_ThreadInfo *) lpParameter;
        
        do
        {
	        /************************************
		     * Test if no internal FIFO overflow 
			 ************************************/

		    if (((ps_ThreadInfo->s_SocketDataFIFO.dw_WritePointer + 1) % MAX_SOKET_DATA_FIFO) != ps_ThreadInfo->s_SocketDataFIFO.dw_ReadPointer)
			{
				/* Calculate the read data size */
				dw_RequestValue         = ps_ThreadInfo->dw_SocketDataSize;
				dw_NbrOfReceiveValues   = 0;

				do
				{
					i_ReturnValue = recv (ps_ThreadInfo->s_ClientSocket, &ps_ThreadInfo->s_SocketDataFIFO.pb_SocketData[ps_ThreadInfo->s_SocketDataFIFO.dw_WritePointer][dw_NbrOfReceiveValues], dw_RequestValue, 0); 

					if (i_ReturnValue != SOCKET_ERROR)
					{
						dw_NbrOfReceiveValues = dw_NbrOfReceiveValues + i_ReturnValue;
						dw_RequestValue = dw_RequestValue - i_ReturnValue;
					}
				}
				while ((dw_NbrOfReceiveValues < ps_ThreadInfo->dw_SocketDataSize) && (i_ReturnValue != SOCKET_ERROR));


				if (i_ReturnValue != SOCKET_ERROR)
				{  
					/************************************
					 * Increment the write FIFO pointer *
					 ************************************/

					ps_ThreadInfo->s_SocketDataFIFO.dw_WritePointer = (ps_ThreadInfo->s_SocketDataFIFO.dw_WritePointer + 1) % MAX_SOKET_DATA_FIFO;

					/**************************
					 * Set the reeceive event *
					 **************************/
					SetEvent (ps_ThreadInfo->h_EventHandle);
				}
				else
				{
					printf("Socket Error %d\n", WSAGetLastError());
        			ps_ThreadInfo->b_Exit = 1;
					SetEvent (ps_ThreadInfo->h_EventHandle);
				}
			}
			else
			{
				printf ("\nInternal sample FIFO overflow. This stop the sample\n");
				ps_ThreadInfo->b_Exit = 1;
				ps_ThreadInfo->s_SocketDataFIFO.b_Overflow = 1;
				SetEvent (ps_ThreadInfo->h_EventHandle);
			}

        } 
        while (ps_ThreadInfo->b_Exit == 0);


        /*********************
        * Return from thread 
        **********************/
        return (0);

        }


DWORD WINAPI dw_SocketDataManagementThreadProc (LPVOID lpParameter)
        {
        str_ThreadInfo *  ps_ThreadInfo;
		INT                i_ReturnValue        = 0;
    	DWORD             dw_Cpt                = 0;
        DWORD             dw_SeqCounter         = 0;
		DWORD             dw_SequenceCounter    = 0;
        CHAR               c_Write   [300];
		str_SequenceData *ps_SequenceData;
		CHAR *pc_Unit[2] = {"V","mA"};

        
        /**************************
        * Variable initialisation 
        ***************************/
        ps_ThreadInfo = (str_ThreadInfo *) lpParameter;
        
        do
        {

			WaitForSingleObject (ps_ThreadInfo->h_EventHandle, INFINITE);

			while ((ps_ThreadInfo->s_SocketDataFIFO.dw_ReadPointer != ps_ThreadInfo->s_SocketDataFIFO.dw_WritePointer) && (ps_ThreadInfo->b_Exit != 2))
			{
				for (dw_SequenceCounter = 0, (BYTE *) ps_SequenceData = ps_ThreadInfo->s_SocketDataFIFO.pb_SocketData[ps_ThreadInfo->s_SocketDataFIFO.dw_ReadPointer];
				     (dw_SequenceCounter < ps_ThreadInfo->dw_NbrMaxSequenceToTransfer) && (ps_ThreadInfo->b_Exit != 2);
					 dw_SequenceCounter ++, (BYTE *) ps_SequenceData = (BYTE *) ps_SequenceData + ps_ThreadInfo->dw_SingelSequenceSize)
				{ 
					c_Write [0] = 0;

					/* Test if the data format time stamp is activated */
					if (ps_ThreadInfo->dw_DataFormat & 1)
					{
				        sprintf(c_Write,"%s %s",c_Write, ConvertTimeStamp (ps_SequenceData->s_WichtTimeStampAndCounterBinaryData.dw_TimeStamp [0],ps_SequenceData->s_WichtTimeStampAndCounterBinaryData.dw_TimeStamp [1]));
					}

				    /* Test if the data format Sequence counter is activated */
					if ((ps_ThreadInfo->dw_DataFormat & 3) == 3)
					{
		               sprintf(c_Write,"%s Sequence counter = %lu",c_Write, ps_SequenceData->s_WichtTimeStampAndCounterBinaryData.dw_Counter);
					}
					else if ((ps_ThreadInfo->dw_DataFormat & 2) == 2)
					{
				       sprintf(c_Write,"%s Sequence counter = %lu", c_Write,ps_SequenceData->s_WichtCounterBinaryData.dw_Counter);
					}

					/* Test if receive digital value and no time stamp and not sequence counter*/
					if ((ps_ThreadInfo->dw_DataFormat & 0x7) == 0x0)
					{
					    for (dw_Cpt = 0; dw_Cpt < ps_ThreadInfo->dw_NumberOfChannelsToAcquire; dw_Cpt ++)
					    { 
						    sprintf(c_Write,"%s %lu:0x%lX",c_Write,dw_Cpt,ps_SequenceData->s_BinaryData.dw_BinaryValue[dw_Cpt]);
					    }
				    }
					/* Test if receive digital value and time stamp and not sequence counter*/
					else if ((ps_ThreadInfo->dw_DataFormat & 0x7) == 0x1)
					{
					    for (dw_Cpt = 0; dw_Cpt < ps_ThreadInfo->dw_NumberOfChannelsToAcquire; dw_Cpt ++)
					    { 
						    sprintf(c_Write,"%s %lu:0x%lX",c_Write,dw_Cpt,ps_SequenceData->s_WichtTimeStampBinaryData.dw_BinaryValue[dw_Cpt]);
					    }
				    }
					/* Test if receive digital value and no time stamp and sequence counter*/
					else if ((ps_ThreadInfo->dw_DataFormat & 0x7) == 0x2)
					{
					    for (dw_Cpt = 0; dw_Cpt < ps_ThreadInfo->dw_NumberOfChannelsToAcquire; dw_Cpt ++)
					    { 
				            sprintf(c_Write,"%s %lu:0x%lX",c_Write,dw_Cpt,ps_SequenceData->s_WichtCounterBinaryData.dw_BinaryValue[dw_Cpt]);
					    }
				    }
					/* Test if receive digital value and time stamp and sequence counter*/
					else if ((ps_ThreadInfo->dw_DataFormat & 0x7) == 0x3)
					{
					    for (dw_Cpt = 0; dw_Cpt < ps_ThreadInfo->dw_NumberOfChannelsToAcquire; dw_Cpt ++)
					    { 
						    sprintf(c_Write,"%s %lu:0x%lX",c_Write,dw_Cpt,ps_SequenceData->s_WichtTimeStampAndCounterBinaryData.dw_BinaryValue[dw_Cpt]);
					    }
				    }

					/* Test if receive analog value and no time stamp and not sequence counter*/
					else if ((ps_ThreadInfo->dw_DataFormat & 0x7) == 0x4)
					{
					    for (dw_Cpt = 0; dw_Cpt < ps_ThreadInfo->dw_NumberOfChannelsToAcquire; dw_Cpt ++)
					    { 
                        sprintf(c_Write,"%s %lu:%f %s",c_Write,dw_Cpt,ps_SequenceData->s_RealData.f_RealValue[dw_Cpt],pc_Unit[(ps_ThreadInfo->dw_ChannelTypeMask >> dw_Cpt) & 1]);
					    }
				    }
					/* Test if receive analog value and time stamp and not sequence counter*/
					else if ((ps_ThreadInfo->dw_DataFormat & 0x7) == 0x5)
					{
					    for (dw_Cpt = 0; dw_Cpt < ps_ThreadInfo->dw_NumberOfChannelsToAcquire; dw_Cpt ++)
					    { 
						    sprintf(c_Write,"%s %lu:%f %s",c_Write,dw_Cpt,ps_SequenceData->s_WichtTimeStampRealData.f_RealValue[dw_Cpt],pc_Unit[(ps_ThreadInfo->dw_ChannelTypeMask >> dw_Cpt) & 1]);
					    }
				    }
					/* Test if receive analog value and no time stamp and sequence counter*/
					else if ((ps_ThreadInfo->dw_DataFormat & 0x7) == 0x6)
					{
					    for (dw_Cpt = 0; dw_Cpt < ps_ThreadInfo->dw_NumberOfChannelsToAcquire; dw_Cpt ++)
					    { 
						    sprintf(c_Write,"%s %lu:%f %s",c_Write,dw_Cpt,ps_SequenceData->s_WichtCounterRealData.f_RealValue[dw_Cpt],pc_Unit[(ps_ThreadInfo->dw_ChannelTypeMask >> dw_Cpt) & 1]);
					    }
				    }
					/* Test if receive analog value and time stamp and sequence counter*/
					else if ((ps_ThreadInfo->dw_DataFormat & 0x7) == 0x7)
					{
					    for (dw_Cpt = 0; dw_Cpt < ps_ThreadInfo->dw_NumberOfChannelsToAcquire; dw_Cpt ++)
					    { 
						    sprintf(c_Write,"%s %lu:%f %s",c_Write,dw_Cpt,ps_SequenceData->s_WichtTimeStampAndCounterRealData.f_RealValue[dw_Cpt],pc_Unit[(ps_ThreadInfo->dw_ChannelTypeMask >> dw_Cpt) & 1]);
					    }
				    }

					sprintf(c_Write,"%s\n", c_Write);
					printf (c_Write);

					/*****************
					 * Test if store *
					 *****************/

					if (ps_ThreadInfo->i_Handle != -1)
					{
						write (ps_ThreadInfo->i_Handle, c_Write, strlen (c_Write));
					}
				}
			
				/***********************************
				 * Increment the read FIFO pointer *
				 ***********************************/

				ps_ThreadInfo->s_SocketDataFIFO.dw_ReadPointer = (ps_ThreadInfo->s_SocketDataFIFO.dw_ReadPointer + 1) % MAX_SOKET_DATA_FIFO;
			}

			if (ps_ThreadInfo->b_Exit)
			{
				ps_ThreadInfo->b_Exit = 2;
			}
        } 
        while (ps_ThreadInfo->b_Exit == 0);

        /*********************
        * Return from thread 
        **********************/
        return (0);

        }




void main(void)
{
	CHAR                                            c_IPAddress    [50];
	CHAR                                            c_IPAddressTemp[50];
	CHAR                                            c_SOAPIPAddress[50];
	INT												i_Error                      = 0;
    INT												i_Handle                     = -1;
	INT												i_CurrentPriority            = 0;
	DWORD                                          dw_Dummy                      = 0;
	DWORD                                          dw_Choice                     = 0;
	DWORD                                          dw_NbrOfChannelsMax           = 16;
	DWORD                                          dw_SockedBufferCounter        = 0;
	xsd__unsignedLong                              dw_NbrOfChannels              = 0;
	xsd__unsignedLong                              dw_ConversionTimeUnit         = 0;
	xsd__unsignedLong                              dw_ConversionTimeValue        = 0;
	xsd__unsignedLong                              dw_NbrOfSequence              = 0;
	xsd__unsignedLong                              dw_NbrMaxSequenceToTransfer   = 0;
	xsd__unsignedLong                              dw_DelayMode                  = 0;
	xsd__unsignedLong                              dw_DelayTimeUnit              = 0;
	xsd__unsignedLong                              dw_DelayValue                 = 0;
	xsd__unsignedLong                              dw_TriggerMask                = 0;
	xsd__unsignedLong                              dw_TriggerMode                = 0;
	xsd__unsignedLong                              dw_HardwareTriggerEdge        = 0;
	xsd__unsignedLong                              dw_HardwareTriggerCount       = 0;
	xsd__unsignedLong                              dw_ByTriggerNbrOfSeqToAcquire = 0;
	xsd__unsignedLong                              dw_DataFormat                 = 0;
	struct MXCommon__ByteArrayResponse              s_ByteArrayResponse;
	struct MSXE302x__Response                      Response;
	struct MSXE302x__unsignedLong16FixedArrayParam dw_ChannelList;
	struct MSXE302x__unsignedLong16FixedArrayParam dw_Gain;
	struct MSXE302x__unsignedLong16FixedArrayParam dw_Polarity;
	struct soap                                   *ps_SoapEnv = NULL;
	SOCKET                                          s_ClientSocket;
	struct MSXE302x__AnalogInputGetChannelTypeResponse GetChannelTypeResponse;
	DWORD dw_ChannelTypeMask = 0;
	CHAR * pc_ChannelType[2] = {"VOLTAGE","CURRENT"};

	
	DWORD	 dw_Cpt					      = 0;
    INT		  i_key		  			      = 0;
	INT		  i_ReturnValue               = 0;
    DWORD    dw_ThreadId                  = 0;
    HANDLE   h_ReadSocketThreadHandle     = 0;
    HANDLE   h_DataManagementThreadHandle = 0;
    str_ThreadInfo   s_ThreadInfo;

	/***************************/
    /* Variable initialisation */
	/***************************/

	memset (&s_ThreadInfo.s_SocketDataFIFO, 0, sizeof (s_ThreadInfo.s_SocketDataFIFO));


	/**************************/
	/* Get the console handle */
	/**************************/
	ShowWindow(GetForegroundWindow (), SW_SHOWMAXIMIZED);

	/****************************/
	/* Print sample information */
	/****************************/
	printf("+---------------------------------------------------+\n");
	printf("| MSX-E302x Sequence                                |\n");
	printf("| MSX-E302x Sequence Test Program                   |\n");
	printf("+---------------------------------------------------+\n");
	printf("| <ESC> exit sample                                 |\n");
	printf("+---------------------------------------------------+\n");
	printf("\n");

	/* Initialise the SOAP connection */
	if (i_SOAP_Init(&ps_SoapEnv) == 0)
	{
		ps_SoapEnv->send_timeout    = 5;
		ps_SoapEnv->recv_timeout    = 5;
		ps_SoapEnv->accept_timeout  = 5;
		ps_SoapEnv->connect_timeout = 1;

		printf("Enter the module IP Address (XXX.XXX.XXX.XXX): ");
		gets(c_IPAddressTemp);

		v_UTILS_ClearNullInIPAddress(c_IPAddressTemp,c_IPAddress);
		sprintf(c_SOAPIPAddress,"%s:5555", c_IPAddress);
		printf("SOAP IP Address: %s\n", c_SOAPIPAddress);

		i_Error = soap_call_MXCommon__GetModuleType(ps_SoapEnv,c_SOAPIPAddress , SOAP_ACTION, &dw_Dummy, &s_ByteArrayResponse);
		if (!(i_CheckAndPrintError (ps_SoapEnv, c_SOAPIPAddress, SOAP_ACTION, i_Error, s_ByteArrayResponse.sResponse.iReturnValue, s_ByteArrayResponse.sResponse.syserrno, "soap_call_MXCommon__GetModuleType", 1)))
		{
			printf("Module Type: %s\n", s_ByteArrayResponse.sArray.__ptr);

			i_Error = soap_call_MSXE302x__AnalogInputGetChannelType(ps_SoapEnv,c_SOAPIPAddress,SOAP_ACTION,0,&GetChannelTypeResponse);
			if (!(i_CheckAndPrintError (ps_SoapEnv, c_SOAPIPAddress, SOAP_ACTION, i_Error, GetChannelTypeResponse.sResponse.iReturnValue, GetChannelTypeResponse.sResponse.syserrno, "soap_call_MSXE302x__AnalogInputGetChannelType", 0)))
			{
				printf("Channels type : \n");
				for (dw_Cpt = 0; dw_Cpt < dw_NbrOfChannelsMax; dw_Cpt ++)
				{
					printf("Channel %lu : %s\n",dw_Cpt,pc_ChannelType[GetChannelTypeResponse.ulType[dw_Cpt]]);
				}



				/* Get the auto sequence initialisation parameter */
				GetSequenceParameters(	dw_NbrOfChannelsMax,
				                        GetChannelTypeResponse.ulType,
				                        &dw_ChannelTypeMask,
											&dw_NbrOfChannels,
											&dw_ChannelList,
											&dw_Gain,
											&dw_Polarity,
											&dw_ConversionTimeValue,
											&dw_ConversionTimeUnit,
											&dw_NbrOfSequence,
											&dw_NbrMaxSequenceToTransfer,
											&dw_DelayMode,
											&dw_DelayTimeUnit,
											&dw_DelayValue,
											&dw_TriggerMask,
											&dw_TriggerMode,
											&dw_HardwareTriggerEdge,
											&dw_HardwareTriggerCount,
											&dw_ByTriggerNbrOfSeqToAcquire,
											&dw_DataFormat);

				s_ThreadInfo.b_Exit                       = 0;
				s_ThreadInfo.dw_DataFormat                = dw_DataFormat;
				s_ThreadInfo.dw_NumberOfChannelsToAcquire = dw_NbrOfChannels;
				s_ThreadInfo.dw_NbrMaxSequenceToTransfer  = dw_NbrMaxSequenceToTransfer;
				s_ThreadInfo.dw_ChannelTypeMask           = dw_ChannelTypeMask;

				/**********************************************/
				/* Calculate the reading the socket data size */
				/**********************************************/

				s_ThreadInfo.dw_SingelSequenceSize = (dw_NbrOfChannels + ((dw_DataFormat & 1) * 2) + ((dw_DataFormat & 2) >> 1)) * sizeof (DWORD);
				s_ThreadInfo.dw_SocketDataSize     = s_ThreadInfo.dw_SingelSequenceSize * dw_NbrMaxSequenceToTransfer;
												
				/* Initialise the socket to receive the data */
				if (i_Socket_ClientOpenEx (c_IPAddress, 8989, s_ThreadInfo.dw_SocketDataSize * MAX_SOKET_DATA_FIFO, &s_ClientSocket) == 0)
				{
					do 
					{
						printf("\nDo You want to store the sequence data (0:No, 1:Yes) ?");
						scanf ("%d",&dw_Choice);
					}
					while (dw_Choice > 1);

					/* Test if store */

					if (dw_Choice)
					{
						i_Handle = open ("Sequence.txt", O_CREAT | O_TRUNC | O_RDWR,S_IREAD | S_IWRITE);
					}

					if (((i_Handle != -1) && (dw_Choice == 1)) || (dw_Choice == 0))
					{
						/*************************************************/
						/* Memory allocation for reading the socket data */
						/*************************************************/

						for (dw_SockedBufferCounter = 0; dw_SockedBufferCounter < MAX_SOKET_DATA_FIFO; dw_SockedBufferCounter ++)
						{
							if ((s_ThreadInfo.s_SocketDataFIFO.pb_SocketData[dw_SockedBufferCounter] = malloc (s_ThreadInfo.dw_SocketDataSize)) == NULL)
							{
								break;
							}
						}


						if (dw_SockedBufferCounter == MAX_SOKET_DATA_FIFO)
						{
							/**************************/
							/* Save the client socket */
							/**************************/

							s_ThreadInfo.s_ClientSocket = s_ClientSocket;
							s_ThreadInfo.i_Handle       = i_Handle;

							/********************************
							 * Thread synchronisation event *
							 ********************************/

							s_ThreadInfo.h_EventHandle = CreateEvent (NULL, FALSE, FALSE, "MSX-E302x sequence");

							/**************************************
							 * Create the read socked data thread *
							 **************************************/

							h_ReadSocketThreadHandle = CreateThread (NULL,
						 	        								 0,
									   								 dw_ReadSocketThreadProc,
																	 &s_ThreadInfo,
																	 0,
																	 &dw_ThreadId);

							/*************************************************************************************************/
							/* Change the process priority to the maximum for the childs to have maximum OS allowed priority */
							/*************************************************************************************************/

							i_CurrentPriority = GetThreadPriority (GetCurrentThread());
							SetThreadPriority (GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);

							SetThreadPriority (h_ReadSocketThreadHandle, THREAD_PRIORITY_TIME_CRITICAL);

							/********************************/
							/* Restore the process priority */
							/********************************/
							
							SetThreadPriority (GetCurrentThread(), i_CurrentPriority);

							Sleep (100);


							/********************************************
							 * Create the socked data management thread *
							 ********************************************/

							h_DataManagementThreadHandle = CreateThread (NULL,
						 	        									 0,
									   									 dw_SocketDataManagementThreadProc,
																		 &s_ThreadInfo,
																		 0,
																		 &dw_ThreadId);

							SetThreadPriority (h_DataManagementThreadHandle, THREAD_PRIORITY_TIME_CRITICAL);


							/* Start the auto refresh */
							i_Error = soap_call_MSXE302x__AnalogInputInitAndStartSequence(					
										ps_SoapEnv,
										c_SOAPIPAddress,
										SOAP_ACTION, 
										dw_NbrOfChannels,
										&dw_ChannelList,
										&dw_Gain,
										&dw_Polarity,
										dw_ConversionTimeValue,
										dw_ConversionTimeUnit,
										dw_NbrOfSequence,
										dw_NbrMaxSequenceToTransfer,
										dw_DelayMode,
										dw_DelayTimeUnit,
										dw_DelayValue,
										dw_TriggerMask,
										dw_TriggerMode,
										dw_HardwareTriggerEdge,
										dw_HardwareTriggerCount,
										dw_ByTriggerNbrOfSeqToAcquire,
										dw_DataFormat,
										0,
										0,
										0,
										&Response);

							if (!(i_CheckAndPrintError (ps_SoapEnv, c_SOAPIPAddress, SOAP_ACTION, i_Error, Response.iReturnValue, Response.syserrno, "soap_call_MSXE302x__AnalogInputInitAndStartSequence", 0)))
							{
								/* 
								 * gSOAP doesn't release automatically the memory that 
								 * it allocates to deserialize data, that's why both 
								 * following functions have to be used to release the 
								 * allocated memory.
								 */
								soap_destroy(ps_SoapEnv);
								soap_end(ps_SoapEnv);

								printf("\n Press ESC to exit the sample...\n");

								do
								{
									if (kbhit()) 
									{
										if (getch() == 27)
										{
											s_ThreadInfo.b_Exit = 2;
										}
									}
									else
									{
										Sleep (100);
									}
								}
								while (s_ThreadInfo.b_Exit != 2);

								Sleep (100);

								/*********************************
								 * Test if internal FIFO overflow
								 *********************************/

								if (s_ThreadInfo.s_SocketDataFIFO.b_Overflow)
								{
									printf ("\nInternal sample FIFO overflow. This have stop the sample\n");
								}
						
								/******************
								* Free the thread 
								*******************/

								i_Error = soap_call_MSXE302x__AnalogInputStopAndReleaseSequence (ps_SoapEnv, c_SOAPIPAddress, SOAP_ACTION, &dw_Dummy, &Response);
								i_CheckAndPrintError (ps_SoapEnv, c_SOAPIPAddress, SOAP_ACTION, i_Error, Response.iReturnValue, Response.syserrno, "soap_call_MSXE302x__AnalogInputStopAndReleaseSequence", 0);
							}
							else
							{
								s_ThreadInfo.b_Exit = 1;
								Sleep (100);
							}
                    
						}
						else
						{
							printf ("Socket memory allocation error\n");
						}

					}
					else
					{
						printf ("Sequence.txt file creation error \n");

					}

					/* Close the socket connection */
					i_Socket_ClientClose(s_ClientSocket);
				}
				else
				{
					printf("i_Socket_ClientOpen Error\n");
				}
			}
		}

	}


	 /* Test if SOAP connection open */

	if (ps_SoapEnv != NULL)
	{
		 /* Close the SOAP connection */
		i_SOAP_Close(ps_SoapEnv);
	}

     /* Test if file open */
	if (i_Handle != -1)
	{
		 /* Close the file */
		close (i_Handle);
	}


    /***************************
     * Test if thread installed 
     ****************************/
    if (h_ReadSocketThreadHandle != 0)
	{
		/*************************
		 * Close the thread handle 
	     **************************/
		CloseHandle (h_ReadSocketThreadHandle);
	}

    /***************************
     * Test if thread installed 
     ****************************/
    if (h_DataManagementThreadHandle != 0)
	{
		/*************************
		 * Close the thread handle 
	     **************************/
		CloseHandle (h_DataManagementThreadHandle);
	}

	/****************************
	 * Free the allocated memory
	 ****************************/

	for (dw_SockedBufferCounter = 0; dw_SockedBufferCounter < MAX_SOKET_DATA_FIFO; dw_SockedBufferCounter ++)
	{
		/**********************************
		 * Test if socket memory allocated 
		 **********************************/
		
		if (s_ThreadInfo.s_SocketDataFIFO.pb_SocketData[dw_SockedBufferCounter] != NULL)
		{
			free (s_ThreadInfo.s_SocketDataFIFO.pb_SocketData[dw_SockedBufferCounter]);
		}
	}

   
	/**********************************/
	/*Print End programme informations*/
	/**********************************/
	printf("\n");
	printf("+---------------------------------------------------+\n");
	printf("| Program stopped                                   |\n");
	printf("+---------------------------------------------------+\n");
	printf("| Press any key to exit from sample                 |\n");
	printf("+---------------------------------------------------+\n");

	while (!(kbhit()));

}
